/*
 *
 * Copyright (C) 2000  Robert Olsson, Jens Ls 
 * Swedish University of Agricultural Sciences
 *
 * This file is part of GNU Zebra.
 *
 * GNU Zebra is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * GNU Zebra is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNU Zebra; see the file COPYING.  If not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  
 */

#define PIM_VTY_PORT 2607
#define PIM_VTYSH_PATH     "/tmp/zpimd"
#define PIM_DEFAULT_CONFIG "zpimd.conf"
#ifndef  SYSCONFDIR
#define SYSCONFDIR "/usr/local/etc/"
#endif

#define TRUE 1
#define FALSE 0

#define PATH_PIMD_PID "/var/run/zpimd.pid"

int  pim_read_packet();
void pim_dump_packet();
void pim_if_start(struct interface *);
void pim_interface_init();

void parse_hello(struct in_addr *, char *, int, struct interface *);
void parse_join_prune(struct in_addr *, char *, int, struct interface *);
void parse_assert(struct in_addr *, char *, int, struct interface *);
void parse_register(struct in_addr *, char *, int, struct interface *);
void parse_register_stop(struct in_addr *, char *, int, struct interface *);
void parse_pim_v2_packet(char *, int, struct interface *);

void send_pim_hello(struct interface *, int);
void send_pim_v2_hello(struct interface *, int);
void send_pim_v2_packet(struct interface *ifp, char *buf, int len, int pim_message, u_int32_t dst, u_int32_t ttl);


int hello_thread_timeout(struct thread *t);

int pim_neighbor_list_add(struct pim_neighbor *);
struct pim_neighbor *pim_neighbor_alloc (void);
int pim_neighbor_list_delete (struct pim_neighbor *pn);
struct pim_neighbor *pim_neighbor_list_lookup_from_in_addr (struct in_addr *);

struct pim_neighbor *pim_neighbor_new( struct in_addr *, int);
int pim_neighbor_remove(struct pim_neighbor *);

void pim_if_stop(struct interface *);
void pim_reset();
void pim_terminate();
void pim_init();
void socket_init();
void vifs_init();
void debug_init();
void rpf_init();
void pim_rp_init();
void pim_assert_init();
void data_timer_init();

int if_group (struct interface *ifp, int sock, u_int32_t group, int add_leave);
int if_add_groups(struct interface *);
int if_drop_groups(struct interface *);

struct interface *get_iflist_ifp(int index);

int igmp_read_raw(struct thread *);
int pim_read_raw(struct thread *);
int data_timer_thread(struct thread *);

int rt_1_wc_1_timeout (struct thread *t_entry_timeout);

extern int hello_thread(struct thread *);
extern int send_join_prune_thread(struct thread *);

extern struct thread_master *master;
extern struct thread *t_pim_raw;
extern struct thread *t_igmp_raw;
extern struct thread *t_pim_data;

/* IGMP */
void send_igmp_packet(struct interface *, char *,int, u_int32_t, u_int32_t);


void route_cmd_init();












